﻿using Bsa.Msa.Common.Services.MessageHandling;
using Bsa.Msa.Common.Settings;
using Bsa.Msa.RabbitMq.Core;
using System;
using System.Collections.Generic;
using System.Text;
using Bsa.Msa.RabbitMq.Core.Interfaces;
using FileStorage.Contracts.Rest.Impl.FileStorage;
using Service.Registry.Common;

namespace Bsa.Msa.Example.Host.Handlers
{
	public sealed class ExampleMessage
	{
		public string FileName { get; set; }
		public string Name { get; set; }
	}
	public sealed class ExampleMessageHandler : IMessageHandler<ExampleMessage>
	{
		private readonly IBusManager _busManager;
		private readonly ISettings _settings;
		private readonly IServiceRegistryFactory _serviceRegistryFactory;

		public ExampleMessageHandler(IBusManager busManager, ISettings settings, IServiceRegistryFactory serviceRegistryFactory)
		{
			this._busManager = busManager;
			this._settings = settings;
			_serviceRegistryFactory = serviceRegistryFactory;
		}
		public void Handle(ExampleMessage message)
		{
			var proxy = _serviceRegistryFactory.CreateRest<IFileStorageRestService, FileStorageRestService>();
			var id = proxy.GetIdByExternal(message.FileName);
			var bytes = new List<byte>(20000*4);
			for (int i = 0; i < 20000; i++)
			{
				var chars = i.ToString();
				bytes.AddRange(Encoding.UTF8.GetBytes(chars));
			}
			proxy.SaveBytes(id, bytes.ToArray(), message.Name, Guid.NewGuid().ToString());
			var size= proxy.GetSize(id, message.Name);
		}
	}
}
